1
0

uninstall.sh 29 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RedHat 7+ Debian 9+ and Ubuntu 16+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit https://oneinstack.com #
  17. #######################################################################
  18. "
  19. # Check if user is root
  20. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  21. oneinstack_dir=$(dirname "`readlink -f $0`")
  22. pushd ${oneinstack_dir} > /dev/null
  23. . ./options.conf
  24. . ./include/color.sh
  25. . ./include/get_char.sh
  26. . ./include/check_dir.sh
  27. Show_Help() {
  28. echo
  29. echo "Usage: $0 command ...[parameters]....
  30. --help, -h Show this help message, More: https://oneinstack.com
  31. --quiet, -q quiet operation
  32. --all Uninstall All
  33. --web Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  34. --mysql Uninstall MySQL/MariaDB/Percona
  35. --postgresql Uninstall PostgreSQL
  36. --mongodb Uninstall MongoDB
  37. --php Uninstall PHP (PATH: ${php_install_dir})
  38. --mphp_ver [53~81] Uninstall another PHP version (PATH: ${php_install_dir}\${mphp_ver})
  39. --allphp Uninstall all PHP
  40. --phpcache Uninstall PHP opcode cache
  41. --php_extensions [ext name] Uninstall PHP extensions, include zendguardloader,ioncube,
  42. sourceguardian,imagick,gmagick,fileinfo,imap,ldap,calendar,phalcon,
  43. yaf,yar,redis,memcached,memcache,mongodb,swoole,xdebug
  44. --pureftpd Uninstall PureFtpd
  45. --redis Uninstall Redis-server
  46. --memcached Uninstall Memcached-server
  47. --phpmyadmin Uninstall phpMyAdmin
  48. --node Uninstall Nodejs (PATH: ${nodejs_install_dir})
  49. "
  50. }
  51. ARG_NUM=$#
  52. TEMP=`getopt -o hvVq --long help,version,quiet,all,web,mysql,postgresql,mongodb,php,mphp_ver:,allphp,phpcache,php_extensions:,pureftpd,redis,memcached,phpmyadmin,node -- "$@" 2>/dev/null`
  53. [ $? != 0 ] && echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  54. eval set -- "${TEMP}"
  55. while :; do
  56. [ -z "$1" ] && break;
  57. case "$1" in
  58. -h|--help)
  59. Show_Help; exit 0
  60. ;;
  61. -q|--quiet)
  62. quiet_flag=y
  63. uninstall_flag=y
  64. shift 1
  65. ;;
  66. --all)
  67. all_flag=y
  68. web_flag=y
  69. mysql_flag=y
  70. postgresql_flag=y
  71. mongodb_flag=y
  72. allphp_flag=y
  73. nodejs_flag=y
  74. pureftpd_flag=y
  75. redis_flag=y
  76. memcached_flag=y
  77. phpmyadmin_flag=y
  78. shift 1
  79. ;;
  80. --web)
  81. web_flag=y; shift 1
  82. ;;
  83. --mysql)
  84. mysql_flag=y; shift 1
  85. ;;
  86. --postgresql)
  87. postgresql_flag=y; shift 1
  88. ;;
  89. --mongodb)
  90. mongodb_flag=y; shift 1
  91. ;;
  92. --php)
  93. php_flag=y; shift 1
  94. ;;
  95. --mphp_ver)
  96. mphp_ver=$2; mphp_flag=y; shift 2
  97. [[ ! "${mphp_ver}" =~ ^5[3-6]$|^7[0-4]$|^8[0-1]$ ]] && { echo "${CWARNING}mphp_ver input error! Please only input number 53~81${CEND}"; exit 1; }
  98. ;;
  99. --allphp)
  100. allphp_flag=y; shift 1
  101. ;;
  102. --phpcache)
  103. phpcache_flag=y; shift 1
  104. ;;
  105. --php_extensions)
  106. php_extensions=$2; shift 2
  107. [ -n "`echo ${php_extensions} | grep -w zendguardloader`" ] && pecl_zendguardloader=1
  108. [ -n "`echo ${php_extensions} | grep -w ioncube`" ] && pecl_ioncube=1
  109. [ -n "`echo ${php_extensions} | grep -w sourceguardian`" ] && pecl_sourceguardian=1
  110. [ -n "`echo ${php_extensions} | grep -w imagick`" ] && pecl_imagick=1
  111. [ -n "`echo ${php_extensions} | grep -w gmagick`" ] && pecl_gmagick=1
  112. [ -n "`echo ${php_extensions} | grep -w fileinfo`" ] && pecl_fileinfo=1
  113. [ -n "`echo ${php_extensions} | grep -w imap`" ] && pecl_imap=1
  114. [ -n "`echo ${php_extensions} | grep -w ldap`" ] && pecl_ldap=1
  115. [ -n "`echo ${php_extensions} | grep -w calendar`" ] && pecl_calendar=1
  116. [ -n "`echo ${php_extensions} | grep -w phalcon`" ] && pecl_phalcon=1
  117. [ -n "`echo ${php_extensions} | grep -w yaf`" ] && pecl_yaf=1
  118. [ -n "`echo ${php_extensions} | grep -w yar`" ] && pecl_yar=1
  119. [ -n "`echo ${php_extensions} | grep -w redis`" ] && pecl_redis=1
  120. [ -n "`echo ${php_extensions} | grep -w memcached`" ] && pecl_memcached=1
  121. [ -n "`echo ${php_extensions} | grep -w memcache`" ] && pecl_memcache=1
  122. [ -n "`echo ${php_extensions} | grep -w mongodb`" ] && pecl_mongodb=1
  123. [ -n "`echo ${php_extensions} | grep -w swoole`" ] && pecl_swoole=1
  124. [ -n "`echo ${php_extensions} | grep -w xdebug`" ] && pecl_xdebug=1
  125. ;;
  126. --node)
  127. nodejs_flag=y; shift 1
  128. ;;
  129. --pureftpd)
  130. pureftpd_flag=y; shift 1
  131. ;;
  132. --redis)
  133. redis_flag=y; shift 1
  134. ;;
  135. --memcached)
  136. memcached_flag=y; shift 1
  137. ;;
  138. --phpmyadmin)
  139. phpmyadmin_flag=y; shift 1
  140. ;;
  141. --)
  142. shift
  143. ;;
  144. *)
  145. echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  146. ;;
  147. esac
  148. done
  149. Uninstall_status() {
  150. if [ "${quiet_flag}" != 'y' ]; then
  151. while :; do echo
  152. read -e -p "Do you want to uninstall? [y/n]: " uninstall_flag
  153. if [[ ! ${uninstall_flag} =~ ^[y,n]$ ]]; then
  154. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  155. else
  156. break
  157. fi
  158. done
  159. fi
  160. }
  161. Print_Warn() {
  162. echo
  163. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  164. }
  165. Print_web() {
  166. [ -d "${nginx_install_dir}" ] && echo ${nginx_install_dir}
  167. [ -d "${tengine_install_dir}" ] && echo ${tengine_install_dir}
  168. [ -d "${openresty_install_dir}" ] && echo ${openresty_install_dir}
  169. [ -e "/etc/init.d/nginx" ] && echo /etc/init.d/nginx
  170. [ -e "/lib/systemd/system/nginx.service" ] && echo /lib/systemd/system/nginx.service
  171. [ -e "/etc/logrotate.d/nginx" ] && echo /etc/logrotate.d/nginx
  172. [ -d "${apache_install_dir}" ] && echo ${apache_install_dir}
  173. [ -e "/lib/systemd/system/httpd.service" ] && echo /lib/systemd/system/httpd.service
  174. [ -e "/etc/init.d/httpd" ] && echo /etc/init.d/httpd
  175. [ -e "/etc/logrotate.d/apache" ] && echo /etc/logrotate.d/apache
  176. [ -d "${tomcat_install_dir}" ] && echo ${tomcat_install_dir}
  177. [ -e "/etc/init.d/tomcat" ] && echo /etc/init.d/tomcat
  178. [ -e "/etc/logrotate.d/tomcat" ] && echo /etc/logrotate.d/tomcat
  179. [ -d "/usr/java" ] && echo /usr/java
  180. [ -d "${apr_install_dir}" ] && echo ${apr_install_dir}
  181. }
  182. Uninstall_Web() {
  183. [ -d "${nginx_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${nginx_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${nginx_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Nginx uninstall completed! ${CEND}"; }
  184. [ -d "${tengine_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${tengine_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${tengine_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Tengine uninstall completed! ${CEND}"; }
  185. [ -d "${openresty_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${openresty_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${openresty_install_dir}/nginx/sbin:@@" /etc/profile; echo "${CMSG}OpenResty uninstall completed! ${CEND}"; }
  186. [ -e "/lib/systemd/system/nginx.service" ] && { systemctl disable nginx > /dev/null 2>&1; rm -f /lib/systemd/system/nginx.service; }
  187. [ -d "${apache_install_dir}" ] && { service httpd stop > /dev/null 2>&1; rm -rf ${apache_install_dir} /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@${apache_install_dir}/bin:@@" /etc/profile; echo "${CMSG}Apache uninstall completed! ${CEND}"; }
  188. [ -e "/lib/systemd/system/httpd.service" ] && { systemctl disable httpd > /dev/null 2>&1; rm -f /lib/systemd/system/httpd.service; }
  189. [ -d "${tomcat_install_dir}" ] && { killall java > /dev/null 2>&1; rm -rf ${tomcat_install_dir} /etc/init.d/tomcat /etc/logrotate.d/tomcat; echo "${CMSG}Tomcat uninstall completed! ${CEND}"; }
  190. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  191. [ -e "${wwwroot_dir}" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  192. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  193. sed -i 's@^backup_content=.*@backup_content=@' ./options.conf
  194. [ -d "${apr_install_dir}" ] && rm -rf ${apr_install_dir}
  195. }
  196. Print_MySQL() {
  197. [ -e "${db_install_dir}" ] && echo ${db_install_dir}
  198. [ -e "/etc/init.d/mysqld" ] && echo /etc/init.d/mysqld
  199. [ -e "/etc/my.cnf" ] && echo /etc/my.cnf
  200. }
  201. Print_PostgreSQL() {
  202. [ -e "${pgsql_install_dir}" ] && echo ${pgsql_install_dir}
  203. [ -e "/etc/init.d/postgresql" ] && echo /etc/init.d/postgresql
  204. [ -e "/lib/systemd/system/postgresql.service" ] && echo /lib/systemd/system/postgresql.service
  205. }
  206. Print_MongoDB() {
  207. [ -e "${mongo_install_dir}" ] && echo ${mongo_install_dir}
  208. [ -e "/etc/init.d/mongod" ] && echo /etc/init.d/mongod
  209. [ -e "/lib/systemd/system/mongod.service" ] && echo /lib/systemd/system/mongod.service
  210. [ -e "/etc/mongod.conf" ] && echo /etc/mongod.conf
  211. }
  212. Uninstall_MySQL() {
  213. # uninstall mysql,mariadb,percona
  214. if [ -d "${db_install_dir}/support-files" ]; then
  215. service mysqld stop > /dev/null 2>&1
  216. rm -rf ${db_install_dir} /etc/init.d/mysqld /etc/my.cnf* /etc/ld.so.conf.d/*{mysql,mariadb,percona}*.conf
  217. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  218. [ -e "${db_data_dir}" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  219. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  220. sed -i "s@${db_install_dir}/bin:@@" /etc/profile
  221. echo "${CMSG}MySQL uninstall completed! ${CEND}"
  222. fi
  223. }
  224. Uninstall_PostgreSQL() {
  225. # uninstall postgresql
  226. if [ -e "${pgsql_install_dir}/bin/psql" ]; then
  227. service postgresql stop > /dev/null 2>&1
  228. rm -rf ${pgsql_install_dir} /etc/init.d/postgresql
  229. [ -e "/lib/systemd/system/postgresql.service" ] && { systemctl disable postgresql > /dev/null 2>&1; rm -f /lib/systemd/system/postgresql.service; }
  230. [ -e "${php_install_dir}/etc/php.d/07-pgsql.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-pgsql.ini
  231. id -u postgres >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel postgres
  232. [ -e "${pgsql_data_dir}" ] && /bin/mv ${pgsql_data_dir}{,$(date +%Y%m%d%H)}
  233. sed -i 's@^dbpostgrespwd=.*@dbpostgrespwd=@' ./options.conf
  234. sed -i "s@${pgsql_install_dir}/bin:@@" /etc/profile
  235. echo "${CMSG}PostgreSQL uninstall completed! ${CEND}"
  236. fi
  237. }
  238. Uninstall_MongoDB() {
  239. # uninstall mongodb
  240. if [ -e "${mongo_install_dir}/bin/mongo" ]; then
  241. service mongod stop > /dev/null 2>&1
  242. rm -rf ${mongo_install_dir} /etc/mongod.conf /etc/init.d/mongod /tmp/mongo*.sock
  243. [ -e "/lib/systemd/system/mongod.service" ] && { systemctl disable mongod > /dev/null 2>&1; rm -f /lib/systemd/system/mongod.service; }
  244. [ -e "${php_install_dir}/etc/php.d/07-mongo.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongo.ini
  245. [ -e "${php_install_dir}/etc/php.d/07-mongodb.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongodb.ini
  246. id -u mongod > /dev/null 2>&1 ; [ $? -eq 0 ] && userdel mongod
  247. [ -e "${mongo_data_dir}" ] && /bin/mv ${mongo_data_dir}{,$(date +%Y%m%d%H)}
  248. sed -i 's@^dbmongopwd=.*@dbmongopwd=@' ./options.conf
  249. sed -i "s@${mongo_install_dir}/bin:@@" /etc/profile
  250. echo "${CMSG}MongoDB uninstall completed! ${CEND}"
  251. fi
  252. }
  253. Print_PHP() {
  254. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  255. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  256. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  257. }
  258. Print_MPHP() {
  259. [ -e "${php_install_dir}${mphp_ver}" ] && echo ${php_install_dir}${mphp_ver}
  260. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && echo /etc/init.d/php${mphp_ver}-fpm
  261. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && echo /lib/systemd/system/php${mphp_ver}-fpm.service
  262. }
  263. Print_ALLPHP() {
  264. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  265. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  266. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  267. for php_ver in 53 54 55 56 70 71 72 73 74 80 81; do
  268. [ -e "${php_install_dir}${php_ver}" ] && echo ${php_install_dir}${php_ver}
  269. [ -e "/etc/init.d/php${php_ver}-fpm" ] && echo /etc/init.d/php${php_ver}-fpm
  270. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && echo /lib/systemd/system/php${php_ver}-fpm.service
  271. done
  272. [ -e "${imagick_install_dir}" ] && echo ${imagick_install_dir}
  273. [ -e "${gmagick_install_dir}" ] && echo ${gmagick_install_dir}
  274. [ -e "${curl_install_dir}" ] && echo ${curl_install_dir}
  275. [ -e "${freetype_install_dir}" ] && echo ${freetype_install_dir}
  276. }
  277. Uninstall_PHP() {
  278. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  279. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  280. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  281. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  282. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  283. }
  284. Uninstall_MPHP() {
  285. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && { service php${mphp_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${mphp_ver}-fpm; }
  286. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && { systemctl stop php${mphp_ver}-fpm > /dev/null 2>&1; systemctl disable php${mphp_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${mphp_ver}-fpm.service; }
  287. [ -e "${php_install_dir}${mphp_ver}" ] && { rm -rf ${php_install_dir}${mphp_ver}; echo "${CMSG}PHP${mphp_ver} uninstall completed! ${CEND}"; }
  288. }
  289. Uninstall_ALLPHP() {
  290. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  291. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  292. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  293. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  294. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  295. for php_ver in 53 54 55 56 70 71 72 73 74 80 81; do
  296. [ -e "/etc/init.d/php${php_ver}-fpm" ] && { service php${php_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${php_ver}-fpm; }
  297. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && { systemctl stop php${php_ver}-fpm > /dev/null 2>&1; systemctl disable php${php_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${php_ver}-fpm.service; }
  298. [ -e "${php_install_dir}${php_ver}" ] && { rm -rf ${php_install_dir}${php_ver}; echo "${CMSG}PHP${php_ver} uninstall completed! ${CEND}"; }
  299. done
  300. [ -e "${imagick_install_dir}" ] && rm -rf ${imagick_install_dir}
  301. [ -e "${gmagick_install_dir}" ] && rm -rf ${gmagick_install_dir}
  302. [ -e "${curl_install_dir}" ] && rm -rf ${curl_install_dir}
  303. [ -e "${freetype_install_dir}" ] && rm -rf ${freetype_install_dir}
  304. }
  305. Uninstall_PHPcache() {
  306. . include/zendopcache.sh
  307. . include/xcache.sh
  308. . include/apcu.sh
  309. . include/eaccelerator.sh
  310. Uninstall_ZendOPcache
  311. Uninstall_XCache
  312. Uninstall_APCU
  313. Uninstall_eAccelerator
  314. # reload php
  315. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  316. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  317. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  318. }
  319. Uninstall_PHPext() {
  320. # ZendGuardLoader
  321. if [ "${pecl_zendguardloader}" == '1' ]; then
  322. . include/ZendGuardLoader.sh
  323. Uninstall_ZendGuardLoader
  324. fi
  325. # ioncube
  326. if [ "${pecl_ioncube}" == '1' ]; then
  327. . include/ioncube.sh
  328. Uninstall_ionCube
  329. fi
  330. # SourceGuardian
  331. if [ "${pecl_sourceguardian}" == '1' ]; then
  332. . include/sourceguardian.sh
  333. Uninstall_SourceGuardian
  334. fi
  335. # imagick
  336. if [ "${pecl_imagick}" == '1' ]; then
  337. . include/ImageMagick.sh
  338. Uninstall_ImageMagick
  339. Uninstall_pecl_imagick
  340. fi
  341. # gmagick
  342. if [ "${pecl_gmagick}" == '1' ]; then
  343. . include/GraphicsMagick.sh
  344. Uninstall_GraphicsMagick
  345. Uninstall_pecl_gmagick
  346. fi
  347. # fileinfo
  348. if [ "${pecl_fileinfo}" == '1' ]; then
  349. . include/pecl_fileinfo.sh
  350. Uninstall_pecl_fileinfo
  351. fi
  352. # imap
  353. if [ "${pecl_imap}" == '1' ]; then
  354. . include/pecl_imap.sh
  355. Uninstall_pecl_imap
  356. fi
  357. # ldap
  358. if [ "${pecl_ldap}" == '1' ]; then
  359. . include/pecl_ldap.sh
  360. Uninstall_pecl_ldap
  361. fi
  362. # calendar
  363. if [ "${pecl_calendar}" == '1' ]; then
  364. . include/pecl_calendar.sh
  365. Uninstall_pecl_calendar
  366. fi
  367. # phalcon
  368. if [ "${pecl_phalcon}" == '1' ]; then
  369. . include/pecl_phalcon.sh
  370. Uninstall_pecl_phalcon
  371. fi
  372. # yaf
  373. if [ "${pecl_yaf}" == '1' ]; then
  374. . include/pecl_yaf.sh
  375. Uninstall_pecl_yaf 2>&1 | tee -a ${oneinstack_dir}/install.log
  376. fi
  377. # yar
  378. if [ "${pecl_yar}" == '1' ]; then
  379. . include/pecl_yar.sh
  380. Uninstall_pecl_yar 2>&1 | tee -a ${oneinstack_dir}/install.log
  381. fi
  382. # pecl_memcached
  383. if [ "${pecl_memcached}" == '1' ]; then
  384. . include/memcached.sh
  385. Uninstall_pecl_memcached
  386. fi
  387. # pecl_memcache
  388. if [ "${pecl_memcache}" == '1' ]; then
  389. . include/memcached.sh
  390. Uninstall_pecl_memcache
  391. fi
  392. # pecl_redis
  393. if [ "${pecl_redis}" == '1' ]; then
  394. . include/redis.sh
  395. Uninstall_pecl_redis
  396. fi
  397. # pecl_mongodb
  398. if [ "${pecl_mongodb}" == '1' ]; then
  399. . include/pecl_mongodb.sh
  400. Uninstall_pecl_mongodb
  401. fi
  402. # swoole
  403. if [ "${pecl_swoole}" == '1' ]; then
  404. . include/pecl_swoole.sh
  405. Uninstall_pecl_swoole
  406. fi
  407. # xdebug
  408. if [ "${pecl_xdebug}" == '1' ]; then
  409. . include/pecl_xdebug.sh
  410. Uninstall_pecl_xdebug
  411. fi
  412. # reload php
  413. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  414. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  415. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  416. }
  417. Menu_PHPext() {
  418. while :; do
  419. echo 'Please select uninstall PHP extensions:'
  420. echo -e "\t${CMSG} 0${CEND}. Do not uninstall"
  421. echo -e "\t${CMSG} 1${CEND}. Uninstall zendguardloader(PHP<=5.6)"
  422. echo -e "\t${CMSG} 2${CEND}. Uninstall ioncube"
  423. echo -e "\t${CMSG} 3${CEND}. Uninstall sourceguardian(PHP<=7.2)"
  424. echo -e "\t${CMSG} 4${CEND}. Uninstall imagick"
  425. echo -e "\t${CMSG} 5${CEND}. Uninstall gmagick"
  426. echo -e "\t${CMSG} 6${CEND}. Uninstall fileinfo"
  427. echo -e "\t${CMSG} 7${CEND}. Uninstall imap"
  428. echo -e "\t${CMSG} 8${CEND}. Uninstall ldap"
  429. echo -e "\t${CMSG} 9${CEND}. Uninstall phalcon(PHP>=5.5)"
  430. echo -e "\t${CMSG}10${CEND}. Uninstall redis"
  431. echo -e "\t${CMSG}11${CEND}. Uninstall memcached"
  432. echo -e "\t${CMSG}12${CEND}. Uninstall memcache"
  433. echo -e "\t${CMSG}13${CEND}. Uninstall mongodb"
  434. echo -e "\t${CMSG}14${CEND}. Uninstall swoole"
  435. echo -e "\t${CMSG}15${CEND}. Uninstall xdebug(PHP>=5.5)"
  436. read -e -p "Please input a number:(Default 0 press Enter) " phpext_option
  437. phpext_option=${phpext_option:-0}
  438. [ "${phpext_option}" == '0' ] && break
  439. array_phpext=(${phpext_option})
  440. array_all=(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)
  441. for v in ${array_phpext[@]}
  442. do
  443. [ -z "`echo ${array_all[@]} | grep -w ${v}`" ] && phpext_flag=1
  444. done
  445. if [ "${phpext_flag}" == '1' ]; then
  446. unset phpext_flag
  447. echo; echo "${CWARNING}input error! Please only input number 1 2 3 14 and so on${CEND}"; echo
  448. continue
  449. else
  450. [ -n "`echo ${array_phpext[@]} | grep -w 1`" ] && pecl_zendguardloader=1
  451. [ -n "`echo ${array_phpext[@]} | grep -w 2`" ] && pecl_ioncube=1
  452. [ -n "`echo ${array_phpext[@]} | grep -w 3`" ] && pecl_sourceguardian=1
  453. [ -n "`echo ${array_phpext[@]} | grep -w 4`" ] && pecl_imagick=1
  454. [ -n "`echo ${array_phpext[@]} | grep -w 5`" ] && pecl_gmagick=1
  455. [ -n "`echo ${array_phpext[@]} | grep -w 6`" ] && pecl_fileinfo=1
  456. [ -n "`echo ${array_phpext[@]} | grep -w 7`" ] && pecl_imap=1
  457. [ -n "`echo ${array_phpext[@]} | grep -w 8`" ] && pecl_ldap=1
  458. [ -n "`echo ${array_phpext[@]} | grep -w 9`" ] && pecl_phalcon=1
  459. [ -n "`echo ${array_phpext[@]} | grep -w 10`" ] && pecl_redis=1
  460. [ -n "`echo ${array_phpext[@]} | grep -w 11`" ] && pecl_memcached=1
  461. [ -n "`echo ${array_phpext[@]} | grep -w 12`" ] && pecl_memcache=1
  462. [ -n "`echo ${array_phpext[@]} | grep -w 13`" ] && pecl_mongodb=1
  463. [ -n "`echo ${array_phpext[@]} | grep -w 14`" ] && pecl_swoole=1
  464. [ -n "`echo ${array_phpext[@]} | grep -w 15`" ] && pecl_xdebug=1
  465. break
  466. fi
  467. done
  468. }
  469. Print_PureFtpd() {
  470. [ -e "${pureftpd_install_dir}" ] && echo ${pureftpd_install_dir}
  471. [ -e "/etc/init.d/pureftpd" ] && echo /etc/init.d/pureftpd
  472. [ -e "/lib/systemd/system/pureftpd.service" ] && echo /lib/systemd/system/pureftpd.service
  473. }
  474. Uninstall_PureFtpd() {
  475. [ -e "${pureftpd_install_dir}" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf ${pureftpd_install_dir} /etc/init.d/pureftpd; echo "${CMSG}Pureftpd uninstall completed! ${CEND}"; }
  476. [ -e "/lib/systemd/system/pureftpd.service" ] && { systemctl disable pureftpd > /dev/null 2>&1; rm -f /lib/systemd/system/pureftpd.service; }
  477. }
  478. Print_Redis_server() {
  479. [ -e "${redis_install_dir}" ] && echo ${redis_install_dir}
  480. [ -e "/etc/init.d/redis-server" ] && echo /etc/init.d/redis-server
  481. [ -e "/lib/systemd/system/redis-server.service" ] && echo /lib/systemd/system/redis-server.service
  482. }
  483. Uninstall_Redis_server() {
  484. [ -e "${redis_install_dir}" ] && { service redis-server stop > /dev/null 2>&1; rm -rf ${redis_install_dir} /etc/init.d/redis-server /usr/local/bin/redis-*; echo "${CMSG}Redis uninstall completed! ${CEND}"; }
  485. [ -e "/lib/systemd/system/redis-server.service" ] && { systemctl disable redis-server > /dev/null 2>&1; rm -f /lib/systemd/system/redis-server.service; }
  486. }
  487. Print_Memcached_server() {
  488. [ -e "${memcached_install_dir}" ] && echo ${memcached_install_dir}
  489. [ -e "/etc/init.d/memcached" ] && echo /etc/init.d/memcached
  490. [ -e "/usr/bin/memcached" ] && echo /usr/bin/memcached
  491. }
  492. Uninstall_Memcached_server() {
  493. [ -e "${memcached_install_dir}" ] && { service memcached stop > /dev/null 2>&1; rm -rf ${memcached_install_dir} /etc/init.d/memcached /usr/bin/memcached; echo "${CMSG}Memcached uninstall completed! ${CEND}"; }
  494. }
  495. Print_phpMyAdmin() {
  496. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && echo ${wwwroot_dir}/default/phpMyAdmin
  497. }
  498. Uninstall_phpMyAdmin() {
  499. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && rm -rf ${wwwroot_dir}/default/phpMyAdmin
  500. }
  501. Print_openssl() {
  502. [ -d "${openssl_install_dir}" ] && echo ${openssl_install_dir}
  503. }
  504. Uninstall_openssl() {
  505. [ -d "${openssl_install_dir}" ] && rm -rf ${openssl_install_dir}
  506. }
  507. Print_Nodejs() {
  508. [ -e "${nodejs_install_dir}" ] && echo ${nodejs_install_dir}
  509. [ -e "/etc/profile.d/nodejs.sh" ] && echo /etc/profile.d/nodejs.sh
  510. }
  511. Menu() {
  512. while :; do
  513. printf "
  514. What Are You Doing?
  515. \t${CMSG} 0${CEND}. Uninstall All
  516. \t${CMSG} 1${CEND}. Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  517. \t${CMSG} 2${CEND}. Uninstall MySQL/MariaDB/Percona
  518. \t${CMSG} 3${CEND}. Uninstall PostgreSQL
  519. \t${CMSG} 4${CEND}. Uninstall MongoDB
  520. \t${CMSG} 5${CEND}. Uninstall all PHP
  521. \t${CMSG} 6${CEND}. Uninstall PHP opcode cache
  522. \t${CMSG} 7${CEND}. Uninstall PHP extensions
  523. \t${CMSG} 8${CEND}. Uninstall PureFtpd
  524. \t${CMSG} 9${CEND}. Uninstall Redis
  525. \t${CMSG}10${CEND}. Uninstall Memcached
  526. \t${CMSG}11${CEND}. Uninstall phpMyAdmin
  527. \t${CMSG}12${CEND}. Uninstall Nodejs (PATH: ${nodejs_install_dir})
  528. \t${CMSG} q${CEND}. Exit
  529. "
  530. echo
  531. read -e -p "Please input the correct option: " Number
  532. if [[ ! "${Number}" =~ ^[0-9,q]$|^1[0-3]$ ]]; then
  533. echo "${CWARNING}input error! Please only input 0~12 and q${CEND}"
  534. else
  535. case "$Number" in
  536. 0)
  537. Print_Warn
  538. Print_web
  539. Print_MySQL
  540. Print_PostgreSQL
  541. Print_MongoDB
  542. Print_ALLPHP
  543. Print_PureFtpd
  544. Print_Redis_server
  545. Print_Memcached_server
  546. Print_openssl
  547. Print_phpMyAdmin
  548. Print_Nodejs
  549. Uninstall_status
  550. if [ "${uninstall_flag}" == 'y' ]; then
  551. Uninstall_Web
  552. Uninstall_MySQL
  553. Uninstall_PostgreSQL
  554. Uninstall_MongoDB
  555. Uninstall_ALLPHP
  556. Uninstall_PureFtpd
  557. Uninstall_Redis_server
  558. Uninstall_Memcached_server
  559. Uninstall_openssl
  560. Uninstall_phpMyAdmin
  561. . include/nodejs.sh; Uninstall_Nodejs
  562. else
  563. exit
  564. fi
  565. ;;
  566. 1)
  567. Print_Warn
  568. Print_web
  569. Uninstall_status
  570. [ "${uninstall_flag}" == 'y' ] && Uninstall_Web || exit
  571. ;;
  572. 2)
  573. Print_Warn
  574. Print_MySQL
  575. Uninstall_status
  576. [ "${uninstall_flag}" == 'y' ] && Uninstall_MySQL || exit
  577. ;;
  578. 3)
  579. Print_Warn
  580. Print_PostgreSQL
  581. Uninstall_status
  582. [ "${uninstall_flag}" == 'y' ] && Uninstall_PostgreSQL || exit
  583. ;;
  584. 4)
  585. Print_Warn
  586. Print_MongoDB
  587. Uninstall_status
  588. [ "${uninstall_flag}" == 'y' ] && Uninstall_MongoDB || exit
  589. ;;
  590. 5)
  591. Print_ALLPHP
  592. Uninstall_status
  593. [ "${uninstall_flag}" == 'y' ] && Uninstall_ALLPHP || exit
  594. ;;
  595. 6)
  596. Uninstall_status
  597. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPcache || exit
  598. ;;
  599. 7)
  600. Menu_PHPext
  601. [ "${phpext_option}" != '0' ] && Uninstall_status
  602. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPext || exit
  603. ;;
  604. 8)
  605. Print_PureFtpd
  606. Uninstall_status
  607. [ "${uninstall_flag}" == 'y' ] && Uninstall_PureFtpd || exit
  608. ;;
  609. 9)
  610. Print_Redis_server
  611. Uninstall_status
  612. [ "${uninstall_flag}" == 'y' ] && Uninstall_Redis_server || exit
  613. ;;
  614. 10)
  615. Print_Memcached_server
  616. Uninstall_status
  617. [ "${uninstall_flag}" == 'y' ] && Uninstall_Memcached_server || exit
  618. ;;
  619. 11)
  620. Print_phpMyAdmin
  621. Uninstall_status
  622. [ "${uninstall_flag}" == 'y' ] && Uninstall_phpMyAdmin || exit
  623. ;;
  624. 12)
  625. Print_Nodejs
  626. Uninstall_status
  627. [ "${uninstall_flag}" == 'y' ] && { . include/nodejs.sh; Uninstall_Nodejs; } || exit
  628. ;;
  629. q)
  630. exit
  631. ;;
  632. esac
  633. fi
  634. done
  635. }
  636. if [ ${ARG_NUM} == 0 ]; then
  637. Menu
  638. else
  639. [ "${web_flag}" == 'y' ] && Print_web
  640. [ "${mysql_flag}" == 'y' ] && Print_MySQL
  641. [ "${postgresql_flag}" == 'y' ] && Print_PostgreSQL
  642. [ "${mongodb_flag}" == 'y' ] && Print_MongoDB
  643. if [ "${allphp_flag}" == 'y' ]; then
  644. Print_ALLPHP
  645. else
  646. [ "${php_flag}" == 'y' ] && Print_PHP
  647. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Print_MPHP
  648. fi
  649. [ "${pureftpd_flag}" == 'y' ] && Print_PureFtpd
  650. [ "${redis_flag}" == 'y' ] && Print_Redis_server
  651. [ "${memcached_flag}" == 'y' ] && Print_Memcached_server
  652. [ "${phpmyadmin_flag}" == 'y' ] && Print_phpMyAdmin
  653. [ "${nodejs_flag}" == 'y' ] && Print_Nodejs
  654. [ "${all_flag}" == 'y' ] && Print_openssl
  655. Uninstall_status
  656. if [ "${uninstall_flag}" == 'y' ]; then
  657. [ "${web_flag}" == 'y' ] && Uninstall_Web
  658. [ "${mysql_flag}" == 'y' ] && Uninstall_MySQL
  659. [ "${postgresql_flag}" == 'y' ] && Uninstall_PostgreSQL
  660. [ "${mongodb_flag}" == 'y' ] && Uninstall_MongoDB
  661. if [ "${allphp_flag}" == 'y' ]; then
  662. Uninstall_ALLPHP
  663. else
  664. [ "${php_flag}" == 'y' ] && Uninstall_PHP
  665. [ "${phpcache_flag}" == 'y' ] && Uninstall_PHPcache
  666. [ -n "${php_extensions}" ] && Uninstall_PHPext
  667. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Uninstall_MPHP
  668. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" == 'y' ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPcache; }
  669. [ "${mphp_flag}" == 'y' ] && [ -n "${php_extensions}" ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPext; }
  670. fi
  671. [ "${pureftpd_flag}" == 'y' ] && Uninstall_PureFtpd
  672. [ "${redis_flag}" == 'y' ] && Uninstall_Redis_server
  673. [ "${memcached_flag}" == 'y' ] && Uninstall_Memcached_server
  674. [ "${phpmyadmin_flag}" == 'y' ] && Uninstall_phpMyAdmin
  675. [ "${nodejs_flag}" == 'y' ] && { . include/nodejs.sh; Uninstall_Nodejs; }
  676. [ "${all_flag}" == 'y' ] && Uninstall_openssl
  677. fi
  678. fi